/***************************************************************************
                          history.h  -  description
                             -------------------
    begin                : Sat Feb 10 2001
    copyright            : (C) 2001 by Michael Ramsza
    email                : mramsz@sgh.waw.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/* History management */

/* nom - number of markets, hl  - history length */
int create_history( int nom, int hl, int ***h)
{
    int i,j;
    *h = (int **) malloc( (nom+1)*sizeof(int *));
    for(i=0; i<=nom; i++){
        (*h)[i] = (int *) malloc( (hl)*sizeof(int)); }

    for(i=0; i<=nom; i++){
      for(j=0; j<hl; j++){
        (*h)[i][j] = pf_uniformk(3)-1;
      }
    }
    return 0;
}

/*creating identical histories */
int create_history1( int nom, int hl, int ***h)
{
    int i,j;
    *h = (int **) malloc( (nom+1)*sizeof(int *));
    for(i=0; i<=nom; i++){
        (*h)[i] = (int *) malloc( (hl)*sizeof(int)); }

		for(j=0; j<hl; j++){
        (*h)[nom][j] = pf_uniformk(3)-1;}
    for(i=0; i<nom; i++){
      for(j=0; j<hl; j++){
        (*h)[i][j] = (*h)[nom][j];
      }
    }
    return 0;
}

/* nom - number of markets
   h   - pointer to list of histories */
int remove_history( int nom, int ***h){
    int i;
    
    for(i=0; i<=nom; i++) free((*h)[i]);
    free((*h));
    return 0;
}

int level3(int bit)
{
    int temp, l;
    temp=1;
    for(l=0; l<bit; l++) temp *= 3;
    return temp;
}

/* returns number of history
   h - pointer to local/global history NOT to list of histories
   lenh - length of history - G_HistoryLength */
int hist2num(int *hh, int lenh){
    int l, snum;
    snum=0;
    for(l=0; l<lenh; l++){
	snum += (hh[l]+1)*level3(l);
    }
    return snum;
}

/* rollleft history */
/* h - pointer to local/global history 
   nom - number of markets
   hl - history length
   p - pointer to vector of prices
*/
int rollhistory(int **h, int nom, int hl, int *p){
    int l, q, sp;
    for(l=0; l<=nom; l++){
			if(p[l]<0) sp = -1;
			if(p[l]>0) sp = 1;
			if(p[l]==0) sp = 0;
			for(q=0; q<hl-1; q++){
	    	h[l][q]=h[l][q+1];
			}
			h[l][hl-1]=sp;
    }
    return 0;
}
