/***************************************************************************
                          market.h  -  description
                             -------------------
    begin                : Sat Feb 10 2001
    copyright            : (C) 2001 by Michael Ramsza
    email                : mramsz@sgh.waw.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/* Stuff related to local and global markets */


/* create_vol_price */
/* nom - number of markets */
int create_vol_price(int nom, int **v, int **p){
		int s;
    (*v) = (int *) malloc((nom+1)*sizeof(int));
    (*p) = (int *) malloc((nom+1)*sizeof(int));
		/* it's not really required */
		for(s=0; s<=nom; s++){
			(*v)[s]=0; (*p)[s]=0;
		}
    return 0;
}

int remove_vol_price(int *p, int *v){
    free(p); free(v);
    return 0;
}

/* computes prices and volumes of local/global markets */
/* a - pointer to list fo all agents
   noa - number of agents
   nom - number of markets
   v - pointer to pointer to vector of volumes
   p - pointer to pointer to vector of prices */
int vol_price(AGENT *a, int noa, int nom, int **v, int **p){
    int l;
    for(l=0; l<=nom; l++){
			(*v)[l]=0;
			(*p)[l]=0;
    }
    for(l=0; l<noa; l++){
			(*v)[a[l].market]++;
			(*p)[a[l].market]+=a[l].action[0];
			(*p)[nom]+=a[l].action[1];
    }
    (*v)[nom]=noa;
    return 0;
}

int compute_buyers(AGENT *a, int noa, int nom, int **buy){
    int l;
    for(l=0; l<=nom; l++) (*buy)[l]=0;
    for(l=0; l<noa; l++){
			if(a[l].action[0]==-1) (*buy)[a[l].market]++;
			if(a[l].action[1]==-1) (*buy)[nom]++;
    }
    return 0;
}

